//---------------------------------------------------------------------------
//| ass_arr 2.00
//|
//|        C++ Builder 5.0+
//|    . http://kuu.spb.ru/programming/ass_arr/
//|
//| :  .  <kuu@pochta.ru>
//| http://kuu.spb.ru
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

#ifndef ass_arrH
#define ass_arrH

#include <vcl.h>

class ass_arr;
class ass_arrEl;
class prop_ass_arr;

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//| class ass_arrEl
//|
//| -  .
//---------------------------------------------------------------------------

class ass_arrEl
{
private:
        bool hasSubarray;       //    ,   , . 

        Variant value;          // 
        ass_arr* subarray;      //    ,   . 

public:
        bool ownsSubarray;      //      . ,  
                                //      .

        ass_arr& sub();
        Variant& v();

        ass_arrEl& operator = (Variant v);
        ass_arrEl& operator = (ass_arr& v);
        ass_arrEl& operator = (ass_arr* v);

        bool isSubarray() { return hasSubarray; }

        ass_arrEl();
        ~ass_arrEl();
};

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//| class ass_arr
//|
//|   
//---------------------------------------------------------------------------

class ass_arr
{
public:
        TList* keys;            //  
        TList* values;          //  
                                // ,  ,  
                                //   

        ass_arrEl& operator[] (Variant key);
        Variant& key(int i);

        int indexOf(Variant key);
        int search(Variant v);

        void unSet(Variant key);
        bool isSet(Variant key);
        void Clear();

        int Count();

        ass_arr();
        ~ass_arr();
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//| class prop_ass_arr
//|
//|        
//---------------------------------------------------------------------------

class prop_ass_arr: public ass_arr
{
public:
        prop_ass_arr();

        void toForm(TForm* form);
        void fromForm(TForm* form);

        bool saveSection(void* root, AnsiString k);
        bool loadSection(void* root, AnsiString k);

        ~prop_ass_arr();
};
//---------------------------------------------------------------------------
#endif
