//---------------------------------------------------------------------------
//| ass_arr 2.00
//|
//|        C++ Builder 5.0+
//|    . http://kuu.spb.ru/programming/ass_arr/
//|
//| :  .  <kuu@pochta.ru>
//| http://kuu.spb.ru
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

#include <vcl.h>
#include <Registry.hpp>
#pragma hdrstop

#include "ass_arr.h"

//---------------------------------------------------------------------------
//* ass_arrEl::ass_arrEl()
//*
//* 
//---------------------------------------------------------------------------

ass_arrEl::ass_arrEl()
{
        ownsSubarray = true;
        subarray = NULL;
        hasSubarray = false;
};

//---------------------------------------------------------------------------
//* ass_arr& ass_arrEl::sub()
//*
//*       
//---------------------------------------------------------------------------

ass_arr& ass_arrEl::sub()
{
        return (ass_arr&)*subarray;
};

//---------------------------------------------------------------------------
//* Variant& ass_arrEl::v()
//*
//*   
//---------------------------------------------------------------------------

Variant& ass_arrEl::v()
{
        return (Variant&)value;
};

//---------------------------------------------------------------------------
//* ass_arrEl& ass_arrEl::operator = (Variant v)
//*
//*      
//---------------------------------------------------------------------------

ass_arrEl& ass_arrEl::operator = (Variant v)
{
        if ((ownsSubarray) && (subarray != NULL)) delete subarray;

        subarray = NULL;
        hasSubarray = false;

        value = v;

        return (ass_arrEl&)this;
};

//---------------------------------------------------------------------------
//* ass_arrEl& ass_arrEl::operator = (ass_arr& v)
//*
//*      
//* .
//---------------------------------------------------------------------------

ass_arrEl& ass_arrEl::operator = (ass_arr& v)
{
        hasSubarray = true;

        subarray = &v;
        value = Null;

        return (ass_arrEl&)this;
};

//---------------------------------------------------------------------------
//* ass_arrEl& ass_arrEl::operator = (ass_arr* v)
//*
//*      
//*    (  ).
//---------------------------------------------------------------------------

ass_arrEl& ass_arrEl::operator = (ass_arr* v)
{
        hasSubarray = true;

        subarray = v;
        value = Null;

        return (ass_arrEl&)this;
};

//---------------------------------------------------------------------------
//* ass_arrEl& ass_arrEl::operator = (ass_arr* v)
//*
//*  .
//---------------------------------------------------------------------------

ass_arrEl::~ass_arrEl()
{
        if ((ownsSubarray) && (hasSubarray) && (subarray != NULL)) delete subarray;
};

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//* ass_arr::ass_arr()
//*
//* 
//---------------------------------------------------------------------------

ass_arr::ass_arr()
{
        keys = new TList;
        values = new TList;
};

//---------------------------------------------------------------------------
//* int ass_arr::indexOf(Variant key)
//*
//*       -1,    
//---------------------------------------------------------------------------

int ass_arr::indexOf(Variant key)
{
        int i;

        for (i = 0; i < keys->Count; i++)
        {
                if (VarType(*(Variant*)keys->Items[i]) == VarType(key))
                        if ((*(Variant*)keys->Items[i]) == key)
                        {
                                return i;
                        }
        }

        return -1;
};

//---------------------------------------------------------------------------
//* ass_arrEl& ass_arr::operator [](Variant key)
//*
//*     
//---------------------------------------------------------------------------

ass_arrEl& ass_arr::operator [](Variant key)
{
        int i;
        Variant* v;
        ass_arrEl* a;

        i = indexOf(key);

        if (i < 0)
        {
                v = new Variant;
                *v = key;

                keys->Add(v);

                a = new ass_arrEl;
                values->Add(a);

                return *a;
        } else {
                return (*(ass_arrEl*)values->Items[i]);
        }
};

//---------------------------------------------------------------------------
//* void ass_arr::unSet(Variant key)
//*
//*      
//---------------------------------------------------------------------------

void ass_arr::unSet(Variant key)
{
        int i = indexOf(key);

        delete keys->Items[i];
        delete values->Items[i];

        keys->Delete(i);
        values->Delete(i);
};

//---------------------------------------------------------------------------
//* Variant& ass_arr::key(int i)
//*
//*      Unassigned,     
//*  
//---------------------------------------------------------------------------

Variant& ass_arr::key(int i)
{
        if (i < keys->Count)
                return (*(Variant*)keys->Items[i]);
        else
                return Unassigned;
};

//---------------------------------------------------------------------------
//* bool ass_arr::isSet(Variant key)
//*
//* ,     
//---------------------------------------------------------------------------

bool ass_arr::isSet(Variant key)
{
        if (indexOf(key) > -1) return true; else return false;
};

//---------------------------------------------------------------------------
//* int ass_arr::Count()
//*
//*     
//---------------------------------------------------------------------------

int ass_arr::Count()
{
        return keys->Count;
};

//---------------------------------------------------------------------------
//* void ass_arr::Clear()
//*
//*  
//---------------------------------------------------------------------------

void ass_arr::Clear()
{
        int i, c;

        c = Count();

        if (c < 0) return;

        for (i = 0; i < c; i++)
        {
                unSet(key(0));
        };
};

//---------------------------------------------------------------------------
//* int ass_arr::search(Variant v)
//*
//*       -1,    
//---------------------------------------------------------------------------

int ass_arr::search(Variant v)
{
        int i;

        for (i = 0; i < values->Count; i++)
        {
                if (VarType((*(ass_arrEl*)values->Items[i]).v()) == VarType(v))
                        if ((*(ass_arrEl*)values->Items[i]).v() == v)
                        {
                                return i;
                        }
        }

        return -1;
};

//---------------------------------------------------------------------------
//* ass_arr::~ass_arr()
//*
//* 
//---------------------------------------------------------------------------

ass_arr::~ass_arr()
{
        Clear();

        delete keys;
        delete values;
};

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//* ass_arr::~ass_arr()
//*
//* 
//---------------------------------------------------------------------------

prop_ass_arr::prop_ass_arr():ass_arr()
{
};

//---------------------------------------------------------------------------
//* void prop_ass_arr::toForm(TForm* form)
//*
//*     
//---------------------------------------------------------------------------

void prop_ass_arr::toForm(TForm* form)
{
        int i;
        ass_arrEl el;
        AnsiString cn;

        for (i = 0; i < form->ComponentCount; i++)
        {
                if (isSet(form->Components[i]->Name))
                {
                        el = (*this)[form->Components[i]->Name];
                        cn = form->Components[i]->ClassName();

                        if (cn == "TEdit")
                        {
                                TEdit* e = (TEdit*)form->Components[i];
                                e->Text = el.v();
                        }
                }
        }
}

//---------------------------------------------------------------------------
//* void prop_ass_arr::toForm(TForm* form)
//*
//*     
//---------------------------------------------------------------------------

void prop_ass_arr::fromForm(TForm* form)
{
        int i;
        ass_arrEl el;
        AnsiString cn;

        for (i = 0; i < form->ComponentCount; i++)
        {
                cn = form->Components[i]->ClassName();

                if (cn == "TEdit")
                {
                        TEdit* e = (TEdit*)form->Components[i];
                        (*this)[form->Components[i]->Name] = e->Text;
                }
        }
}

//---------------------------------------------------------------------------
//* bool prop_ass_arr::loadSection(void* root, AnsiString k)
//*
//*       (root - 
//*  , k -   )
//---------------------------------------------------------------------------

bool prop_ass_arr::loadSection(void* root, AnsiString k)
{
        TRegistry *Registry = new TRegistry;
        TStringList* vs;
        TStringList* ks;
        TRegDataType t;
        ass_arr* a;
        prop_ass_arr* s;

        int i;

        Registry->RootKey = root;

        if (Registry->OpenKey(k, false))
        {
                vs = new TStringList;
                ks = new TStringList;

                Registry->GetKeyNames(ks);
                Registry->GetValueNames(vs);

                Clear();

                a = this;

                if (ks->Count > 0)
                {
                        for (i = 0; i < ks->Count; i++)
                        {
                                s = new prop_ass_arr;
                                s->loadSection(root, k+"\\"+ks->Strings[i]);
                                (*a)[ks->Strings[i]] = s;
                        }
                }

                for (i = 0; i < vs->Count; i++)
                {
                        t = Registry->GetDataType(vs->Strings[i]);

                        if (t == rdString)
                        {
                                (*a)[vs->Strings[i]] = Registry->ReadString(vs->Strings[i]);
                        }

                        if (t == rdInteger)
                        {
                                (*a)[vs->Strings[i]] = Registry->ReadInteger(vs->Strings[i]);
                        }
                }

                Registry->CloseKey();

                delete vs;
                delete ks;

                return true;
        }

        return false;
};

//---------------------------------------------------------------------------
//* bool prop_ass_arr::saveSection(void* root, AnsiString k)
//*
//*       (root - 
//*  , k -   )
//---------------------------------------------------------------------------

bool prop_ass_arr::saveSection(void* root, AnsiString k)
{
        TRegistry *Registry = new TRegistry;
        ass_arr* a;
        ass_arrEl e;

        int i;
        Variant v;

        Registry->RootKey = root;

        Registry->DeleteKey(k);
        if (Registry->OpenKey(k, true))
        {
                a = this;

                for (i = 0; i < a->Count(); i++)
                {
                        e = (*a)[a->key(i)];

                        if (e.isSubarray())
                        {
                                prop_ass_arr* arr = (prop_ass_arr*)&e.sub();
                                arr->saveSection(root, k+"\\"+a->key(i));
                                continue;
                        }

                        v = e.v();

                        if (VarType(v) == varString)
                        {
                                Registry->WriteString(a->key(i), v);
                        }

                        if (VarType(v) == varBoolean)
                        {
                                Registry->WriteBool(a->key(i), v);
                        }

                        if ((VarType(v) == varInteger) || (VarType(v) == varSmallint))
                        {
                                Registry->WriteInteger(a->key(i), v);
                        }

                        if ((VarType(v) == varDouble) || (VarType(v) == varSingle))
                        {
                                Registry->WriteFloat(a->key(i), v);
                        }
                }

                Registry->CloseKey();
        } else {
                return false;
        }

        return true;
};

//---------------------------------------------------------------------------
//* prop_ass_arr::~prop_ass_arr()
//*
//* 
//---------------------------------------------------------------------------

prop_ass_arr::~prop_ass_arr()
{
};

#pragma package(smart_init)
